Package com.xebialabs.xlrelease.domain.delivery

## Class Delivery

- java.lang.Object
- - com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem
  - - com.xebialabs.xlrelease.domain.delivery.Delivery

- All Implemented Interfaces:
    `ConfigurationItem`, `CiWithInternalMetadata`, `java.io.Serializable`, `java.lang.Comparable<BaseConfigurationItem>`

      @Metadata(root=BY_ROOT_NAME,
                rootName="Deliveries",
                versioned=false)
      public class Delivery
      extends BaseConfigurationItem
      implements CiWithInternalMetadata

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `DELIVERY_ROOT` |

    - ### Fields inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

      `id, syntheticProperties, type`

    - ### Fields inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

      `SYNTHETIC_PROPERTIES_FIELD, TYPE_FIELD`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Delivery()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addReleaseId​(java.lang.String releaseId)` |
    `void` | `addReleaseIds​(java.util.Set<java.lang.String> releaseIds)` |
    `void` | `addStage​(Stage stage)` |
    `void` | `addStage​(Stage stage, int position)` |
    `void` | `addSubscriber​(Subscriber subscriber)` |
    `void` | `addTrackedItem​(TrackedItem item)` |
    `void` | `computeReleasesFromTrackedItems()` |
    `java.util.Optional<Stage>` | `findFirstOpenStage()` |
    `java.util.Optional<TrackedItem>` | `findItemByIdOrTitle​(java.lang.String idOrTitle)` |
    `java.util.Optional<Stage>` | `findNextStage​(Stage stage)` |
    `java.util.Optional<Stage>` | `findPreviousStage​(Stage stage)` |
    `java.util.Optional<Stage>` | `findStageByIdOrTitle​(java.lang.String idOrTitle)` |
    `java.util.Optional<Subscriber>` | `findSubscriberBySourceId​(java.lang.String sourceId)` |
    `java.util.Optional<Transition>` | `findTransitionByIdOrTitle​(java.lang.String transitionIdOrTitle)` |
    `java.util.Map<java.lang.String,​InternalMetadata>` | `get$metadata()` |
    `java.lang.String` | `getDescription()` |
    `java.util.Date` | `getEndDate()` |
    `java.lang.String` | `getFolderId()` |
    `TrackedItem` | `getItemByIdOrTitle​(java.lang.String idOrTitle)` |
    `java.lang.String` | `getOriginPatternId()` |
    `java.lang.Integer` | `getPlannedDuration()` |
    `java.util.Set<java.lang.String>` | `getReleaseIds()` |
    `Stage` | `getStageByIdOrTitle​(java.lang.String idOrTitle)` |
    `Stage` | `getStageByTransition​(Transition transition)` |
    `Stage` | `getStageByTransitionId​(java.lang.String transitionId)` |
    `java.util.List<Stage>` | `getStageGroupAfterTransition​(Transition transition)` |
    `java.util.List<Stage>` | `getStageGroupOfStage​(Stage stage)` |
    `java.util.List<Stage>` | `getStages()` |
    `java.util.List<Stage>` | `getStagesBefore​(Stage stage)` |
    `java.util.List<Stage>` | `getStagesBeforeFirstOpenTransition()` |
    `java.util.Date` | `getStartDate()` |
    `DeliveryStatus` | `getStatus()` |
    `java.util.List<Subscriber>` | `getSubscribers()` |
    `<T extends Subscriber> java.util.List<T>` | `getSubscribersOfType​(java.lang.Class<T> subscriberClass)` |
    `java.lang.String` | `getTitle()` |
    `java.util.List<TrackedItem>` | `getTrackedItems()` |
    `Transition` | `getTransitionByIdOrTitle​(java.lang.String transitionIdOrTitle)` |
    `java.util.List<Transition>` | `getTransitions()` |
    `boolean` | `isAutoComplete()` |
    `boolean` | `isLastStage​(Stage stage)` |
    `boolean` | `isTemplate()` |
    `boolean` | `isUpdatable()` |
    `void` | `removeReleaseIds​(java.util.List<java.lang.String> idsToRemove)` |
    `void` | `removeStage​(Stage stage)` |
    `void` | `removeTrackedItem​(java.lang.String itemId)` |
    `void` | `setAutoComplete​(boolean autoComplete)` |
    `void` | `setDescription​(java.lang.String description)` |
    `void` | `setEndDate​(java.util.Date endDate)` |
    `void` | `setFolderId​(java.lang.String folderId)` |
    `void` | `setOriginPatternId​(java.lang.String originPatternId)` |
    `void` | `setPlannedDuration​(java.lang.Integer plannedDuration)` |
    `void` | `setReleaseIds​(java.util.Set<java.lang.String> releaseIds)` |
    `void` | `setStages​(java.util.List<Stage> stages)` |
    `void` | `setStartDate​(java.util.Date startDate)` |
    `void` | `setStatus​(DeliveryStatus status)` |
    `void` | `setSubscribers​(java.util.List<Subscriber> subscribers)` |
    `void` | `setTitle​(java.lang.String title)` |
    `void` | `setTrackedItems​(java.util.List<TrackedItem> trackedItems)` |
    `void` | `updateDuration()` |

    - ### Methods inherited from class com.xebialabs.deployit.plugin.api.udm.base.BaseConfigurationItem

      `compareTo, equals, get$ciAttributes, get$directoryReference, get$externalProperties, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$token, get$validationMessages, getId, getName, getProperty, getPropertyDescriptor, getType, hashCode, hasProperty, set$ciAttributes, set$directoryReference, set$externalProperties, set$internalId, set$referenceId, set$securedCi, set$securedDirectoryReference, set$token, set$validationMessages, setId, setProperty, setType, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.xebialabs.deployit.plugin.api.udm.ConfigurationItem

      `get$directoryReference, get$internalId, get$referenceId, get$securedCi, get$securedDirectoryReference, get$validationMessages, getId, getName, getProperty, getType, hasProperty, setId, setProperty`

- - ### Field Detail

    - #### DELIVERY_ROOT

          public static final java.lang.String DELIVERY_ROOT

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Delivery

          public Delivery()

  - ### Method Detail

    - #### isTemplate

          public boolean isTemplate()

    - #### updateDuration

          public void updateDuration()

    - #### findItemByIdOrTitle

          public java.util.Optional<TrackedItem> findItemByIdOrTitle​(java.lang.String idOrTitle)

    - #### getItemByIdOrTitle

          public TrackedItem getItemByIdOrTitle​(java.lang.String idOrTitle)

    - #### addStage

          public void addStage​(Stage stage)

    - #### addStage

          public void addStage​(Stage stage,
                               int position)

    - #### removeStage

          public void removeStage​(Stage stage)

    - #### isLastStage

          public boolean isLastStage​(Stage stage)

    - #### findFirstOpenStage

          public java.util.Optional<Stage> findFirstOpenStage()

    - #### findPreviousStage

          public java.util.Optional<Stage> findPreviousStage​(Stage stage)

    - #### findNextStage

          public java.util.Optional<Stage> findNextStage​(Stage stage)

    - #### findStageByIdOrTitle

          public java.util.Optional<Stage> findStageByIdOrTitle​(java.lang.String idOrTitle)

    - #### getStageByIdOrTitle

          public Stage getStageByIdOrTitle​(java.lang.String idOrTitle)

    - #### getTransitions

          public java.util.List<Transition> getTransitions()

    - #### findTransitionByIdOrTitle

          public java.util.Optional<Transition> findTransitionByIdOrTitle​(java.lang.String transitionIdOrTitle)

    - #### getTransitionByIdOrTitle

          public Transition getTransitionByIdOrTitle​(java.lang.String transitionIdOrTitle)

    - #### getStageByTransition

          public Stage getStageByTransition​(Transition transition)

    - #### getStageByTransitionId

          public Stage getStageByTransitionId​(java.lang.String transitionId)

    - #### getStagesBeforeFirstOpenTransition

          public java.util.List<Stage> getStagesBeforeFirstOpenTransition()

    - #### getStagesBefore

          public java.util.List<Stage> getStagesBefore​(Stage stage)

    - #### getStageGroupAfterTransition

          public java.util.List<Stage> getStageGroupAfterTransition​(Transition transition)

    - #### getStageGroupOfStage

          public java.util.List<Stage> getStageGroupOfStage​(Stage stage)

    - #### getSubscribersOfType

          public <T extends Subscriber> java.util.List<T> getSubscribersOfType​(java.lang.Class<T> subscriberClass)

    - #### addSubscriber

          public void addSubscriber​(Subscriber subscriber)

    - #### findSubscriberBySourceId

          public java.util.Optional<Subscriber> findSubscriberBySourceId​(java.lang.String sourceId)

    - #### getTitle

          public java.lang.String getTitle()

    - #### setTitle

          public void setTitle​(java.lang.String title)

    - #### getDescription

          public java.lang.String getDescription()

    - #### setDescription

          public void setDescription​(java.lang.String description)

    - #### getStatus

          public DeliveryStatus getStatus()

    - #### setStatus

          public void setStatus​(DeliveryStatus status)

    - #### getStartDate

          public java.util.Date getStartDate()

    - #### setStartDate

          public void setStartDate​(java.util.Date startDate)

    - #### getEndDate

          public java.util.Date getEndDate()

    - #### setEndDate

          public void setEndDate​(java.util.Date endDate)

    - #### getReleaseIds

          public java.util.Set<java.lang.String> getReleaseIds()

    - #### setReleaseIds

          public void setReleaseIds​(java.util.Set<java.lang.String> releaseIds)

    - #### removeReleaseIds

          public void removeReleaseIds​(java.util.List<java.lang.String> idsToRemove)

    - #### isUpdatable

          public boolean isUpdatable()

    - #### getFolderId

          public java.lang.String getFolderId()

    - #### setFolderId

          public void setFolderId​(java.lang.String folderId)

    - #### getOriginPatternId

          public java.lang.String getOriginPatternId()

    - #### setOriginPatternId

          public void setOriginPatternId​(java.lang.String originPatternId)

    - #### get$metadata

          public java.util.Map<java.lang.String,​InternalMetadata> get$metadata()

      Specified by:
        `get$metadata` in interface `CiWithInternalMetadata`

    - #### getTrackedItems

          public java.util.List<TrackedItem> getTrackedItems()

    - #### setTrackedItems

          public void setTrackedItems​(java.util.List<TrackedItem> trackedItems)

    - #### getStages

          public java.util.List<Stage> getStages()

    - #### setStages

          public void setStages​(java.util.List<Stage> stages)

    - #### addReleaseId

          public void addReleaseId​(java.lang.String releaseId)

    - #### addReleaseIds

          public void addReleaseIds​(java.util.Set<java.lang.String> releaseIds)

    - #### addTrackedItem

          public void addTrackedItem​(TrackedItem item)

    - #### removeTrackedItem

          public void removeTrackedItem​(java.lang.String itemId)

    - #### getPlannedDuration

          public java.lang.Integer getPlannedDuration()

    - #### setPlannedDuration

          public void setPlannedDuration​(java.lang.Integer plannedDuration)

    - #### getSubscribers

          public java.util.List<Subscriber> getSubscribers()

    - #### setSubscribers

          public void setSubscribers​(java.util.List<Subscriber> subscribers)

    - #### computeReleasesFromTrackedItems

          public void computeReleasesFromTrackedItems()

    - #### isAutoComplete

          public boolean isAutoComplete()

    - #### setAutoComplete

          public void setAutoComplete​(boolean autoComplete)